using namespace std;

int main()
{
    int n,m,a,b,t,u,v,br,t1=0;
    cin>>n>>m;
    for(int i=0;i<m;i++)
    {
        cin>>a>>b>>t;
        if(t!=t1)
        {
            br++;
            t1=t;
        }
    }
    cin>>u>>v;
    cout<<br;
    return 0;
}